package main.controler;

import main.entity.CustomerE;
import main.repository.CustomerRepo;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;

@Controller    // This means that this class is a Controller
@RequestMapping(path="/customer") // This means URL's start with /demo (after Application path)
public class CustomerController {
    @Autowired // This means to get the bean called userRepository
    // Which is auto-generated by Spring, we will use it to handle the data
    private CustomerRepo customerRepo;

    @GetMapping(path="/add") // Map ONLY POST Requests
    public @ResponseBody String addNewUser (@RequestParam String firstName
            , @RequestParam String lastName) {
        // @ResponseBody means the returned String is the response, not a view name
        // @RequestParam means it is a parameter from the GET or POST request
        CustomerE newCustomer = new CustomerE();
        newCustomer.setFirstName(firstName);
        newCustomer.setLastName(lastName);
        customerRepo.save(newCustomer);
        return "Saved";
    }

    @GetMapping(path="/all")
    public @ResponseBody Iterable<CustomerE> getAllUsers() {
        // This returns a JSON or XML with the users
        return customerRepo.findAll();
    }
}